<%
'*************************************************************************
' DO NOT MODIFY THIS SCRIPT IF YOU WANT UPDATES TO WORK!
' Function : Basic shipping calculation routines
' Product  : Shopping Tree Store Frontend
' Version  : 3.3
' Modified : January 2005
' Copyright: Copyright (C) 2004 Shopping Tree.Com 
'            See "license.txt" for this product for details regarding 
'            licensing, usage, disclaimers, distribution and general 
'            copyright requirements. If you don't have a copy of this 
'            file, you may request one at webmaster@ShoppingTree.com
'*************************************************************************

'*************************************************************************
'Variables
'*************************************************************************

'Shipping rate array
dim shipArray
redim shipArray(100,1)

'Totals for items that require shipping
dim totalShipPrice
dim totalShipWeight
dim totalShipItems
dim shippingaddrType

'*************************************************************************
'Calculate Totals that will be used to calculate shipping rates
'*************************************************************************
sub calcShipTotals(idOrder)

	'Variables
	dim mySQL, rsTemp
	
	'Initialise
	totalShipPrice	= 0
	totalShipWeight	= 0
	totalShipItems  = 0
	
	'Determine totals
	mySQL="SELECT a.idCartRow, a.quantity " _
		& "FROM   cartRows a, products b " _
		& "WHERE  a.idOrder = " & validSQL(idOrder,"I") & " " _
		& "AND    b.idProduct = a.idProduct " _
		& "AND   (b.noShipCharge IS NULL " _
		& "OR     b.noShipCharge <> 'Y') "
	set rsTemp = openRSexecute(mySQL)
	do while not rsTemp.EOF
		totalShipPrice  = Cdbl(totalShipPrice  + cartTotal(idOrder,rsTemp("idCartRow")))
		totalShipWeight = Cdbl(totalShipWeight + cartRowWeight(idOrder,rsTemp("idCartRow")))
		totalShipItems  = Cdbl(totalShipItems  + rsTemp("quantity"))
		rsTemp.MoveNext
	loop
	call closeRS(rsTemp)

end sub

'*************************************************************************
'Calculate Cart Row Weight
'*************************************************************************
function cartRowWeight(idOrder,idCartRow)
	dim mySQL, rsTemp, quantity, unitWeight, optionWeight
	cartRowWeight = CDbl(0)
	mySQL = "SELECT quantity, unitWeight, " _
		  & "      (SELECT SUM(optionWeight) " _
		  & "       FROM   cartRowsOptions " _
		  & "       WHERE  cartRowsOptions.idCartRow = cartRows.idCartRow) " _
		  & "       AS     optionWeight " _
		  & "FROM   cartRows " _
		  & "WHERE  idOrder   = " & validSQL(idOrder,"I") & " " _
		  & "AND    idCartRow = " & validSQL(idCartRow,"I") & " "
	set rsTemp = openRSexecute(mySQL)
	do while not rsTemp.eof
		quantity      = CDbl(emptyString(rsTemp("quantity"),"0"))
		unitWeight    = CDbl(emptyString(rsTemp("unitWeight"),"0"))
		optionWeight  = CDbl(emptyString(rsTemp("optionWeight"),"0"))
		cartRowWeight = cartRowWeight + (quantity * (unitWeight + optionWeight))
		rsTemp.movenext
	loop
	call closeRS(rsTemp)
end function

'******************************************************************
'Calculate Store Rates
'******************************************************************
sub calcStoreRates(cartSubTotal, cartWeight, locShipZone)

	'Variables
	dim addAmt, addPerc, shipDesc, f
	dim mySQL, rsTemp
	
	'Initialize Counter
	f = 0

	'Get shipping rate records
	mySQL="SELECT a.addAmt,a.addPerc,b.shipDesc " _
	    & "FROM   shipRates a, shipMethod b " _
	    & "WHERE  a.idShipMethod = b.idShipMethod " _ 
	    & "AND    b.status = 'A' " _
	    & "AND    locShipZone = " & validSQL(locShipZone,"I") & " " _
	    & "AND   (addAmt IS NOT NULL OR addPerc IS NOT NULL) " _
	    & "AND  ((unitType='P' AND unitsFrom <= " & validSQL(cartSubTotal,"D") & " AND unitsTo >= " & validSQL(cartSubTotal,"D") & ") " _
	    & "OR    (unitType='W' AND unitsFrom <= " & validSQL(cartWeight,"D")   & " AND unitsTo >= " & validSQL(cartWeight,"D")   & ")) " _
	    & "ORDER BY a.idShipMethod " 
	set rsTemp = openRSexecute(mySQL)
	do while not rsTemp.eof

		'Get values from recordset
		addAmt   = rsTemp("addAmt")
		addPerc  = rsTemp("addPerc")
		shipDesc = trim(rsTemp("shipDesc")&"")

		'Calculate shipping based on fixed amount or percentage of 
		'order total (whichever is the greater value).
		if IsNull(addAmt) then
			addAmt = Round(((cartSubTotal * addPerc) / 100),2)
		else
			if not IsNull(addPerc) then
				if addAmt < ((cartSubTotal * addPerc) / 100) then
					addAmt = Round(((cartSubTotal * addPerc) / 100),2)
				end if
			end if
		end if
			
		'Move values into array, whilst making sure that we move 
		'the largest amount for each shipping method group.
		if f = 0 then '1st position in the array
			shipArray(f,0) = addAmt
			shipArray(f,1) = shipDesc
			f = f + 1
		else
			if lCase(shipDesc) = lCase(shipArray(f-1,1)) then
				if  shipArray(f-1,0) < addAmt then
					shipArray(f-1,0) = addAmt
				end if
			else
				shipArray(f,0) = addAmt
				shipArray(f,1) = shipDesc
				f = f + 1
			end if
		end if
		
		'Read next record
		rsTemp.movenext
			
	loop
	call closeRS(rsTemp)
	
end sub

'******************************************************************
'Calculate Online Rates
'******************************************************************
sub calcOnlineRates(totalShipWeight,shippingLocCountry,shippingLocState,shippingZip)

	'Variables
	dim shipParms
	dim shippingLocCountryDesc
	dim mySQL, rsTemp

	'Store shipArray in session object
	session(storeID & "shipArray") = shipArray
	
	mySQL = "SELECT RateURL " _
	      & "FROM shipvendors " _
	      & "WHERE active = 'Y';"
	      
	set rsTemp = openRSexecute(mySQL)
	do while not rsTemp.eof 
		shipParms = array(totalShipWeight,shippingLocCountry,shippingLocState,shippingZip,shippingaddrtype,totalShipPrice)
		session(storeID & "shipParms") = shipParms
		server.Execute rsTemp("RateURL")
		rsTemp.movenext
	loop
	
	'Move session shipArray back to local shipArray
	shipArray = session(storeID & "shipArray")

	'Clean up session object
	session(storeID & "shipArray")	= null
	session(storeID & "shipParms")	= null
	
end sub

'*************************************************************************
'Check shipping rate array
'*************************************************************************
function validShipArray()
	
	'Variables
	dim f
	
	'Initialise
	validShipArray = true
	
	'Check array
	if isNull(shipArray(0,0)) or isEmpty(shipArray(0,0)) _
	or isNull(shipArray(0,1)) or isEmpty(shipArray(0,1)) _
	or len(shipArray(0,1)) = 0 then
		validShipArray = false
	else
		for f = 0 to UBound(shipArray)
			if  len(trim(shipArray(f,0))) > 0 _
			and len(trim(shipArray(f,1))) > 0  then
				if len(trim(shipArray(f,1))) > 100 _
				or not(isNumeric(shipArray(f,0))) then
					validShipArray = false
				end if
			end if
		next
	end if
	
end function

'*************************************************************************
'Determine Shipping Zone for shipping destination : Null = Error
'Use the lowest level ShipZone found
'*************************************************************************
function getShipZone(shippingLocCountry,shippingLocState,ShippingLocCity,ShippingLocZip)

	'Variables
	dim mySQL, rsTemp, idCountry, idState, idMunicipality, ShipZone			
				
	if len(shippingLocCountry) = 0 then 'no country
		response.redirect "sysMsg.asp?errMsg=" & server.URLEncode(LangText("ErrNoCountry","No Country Code"))
	else
		' ShipZones may be set for Country, State, Municipality, Zip / Postal and the lowest level is used
		' Get ShipZone for Country 
		mySQL = "SELECT ShipZone,idCountry " _
			  & "FROM   Country " _
			  & "WHERE  CountryCode = '" & validSQL(shippingLocCountry,"A") & "' " _
			  & "AND   Status = 'A' "
		set rsTemp = openRSexecute(mySQL)
		if not rsTemp.eof then
			ShipZone = trim(rsTemp("ShipZone")&"")
			if len(ShipZone) = 0 then exit function 
			getShipZone = trim(rsTemp("ShipZone")&"")
			idCountry = trim(rsTemp("idCountry")&"")
		end if		  
		closeRS(rsTemp)
		if len(shippingLocState) > 0 then
			'
			'
			' Get ShipZone for State
			mySQL = "SELECT ShipZone,idState " _
				  & "FROM   states " _
				  & "WHERE  idCountry = " & validSQL(idCountry,"I") & " " _
				  & "AND    Status = 'A' " _
				  & "AND    StateCode = '" & shippingLocState & "'"
			set rsTemp = openRSexecute(mySQL)
			if not rsTemp.eof then
				ShipZone = trim(rsTemp("ShipZone")&"")
				if len(ShipZone) = 0 then exit function 
				getShipZone = trim(rsTemp("ShipZone")&"")
				idState = trim(rsTemp("idState")&"")
			end if		  
			closeRS(rsTemp)
			if len(shippingLocCity) > 0 then				
				'
				'
				' Get ShipZone for Municipality
				mySQL = "SELECT ShipZone,idMunicipality " _
					  & "FROM   municipality " _
					  & "WHERE  MunicipalityName = '" & validSQL(shippingLocCity,"A") & "' " _
					  & "AND    Status = 'A' " _
					  & "AND    idState = " & validSQL(idState,"I") & ";"
				set rsTemp = openRSexecute(mySQL)			  
				if not rsTemp.eof then
					ShipZone = trim(rsTemp("ShipZone")&"")
					if len(ShipZone) = 0 then exit function 
					getShipZone = trim(rsTemp("ShipZone")&"")
					idMunicipality = trim(rsTemp("idMunicipality")&"")
				end if		  
				closeRS(rsTemp)
				'
				'
				' Get ShipZone for Zip
				mySQL = "SELECT ShipZone " _
					  & "FROM   ZipPostalCodes " _
					  & "WHERE  Status = 'A' " _
					  & "AND    ZipCode = '" & shippingLocZip & "'"
				set rsTemp = openRSexecute(mySQL)
				if not rsTemp.eof then
					ShipZone = trim(rsTemp("ShipZone")&"")
					if len(ShipZone) = 0 then exit function 
					getShipZone = trim(rsTemp("ShipZone")&"")
				end if		  
				closeRS(rsTemp)
			end if
		end if
	end if
	
end function
%>